part of xwidgetbase;

class XBtnbase extends StatelessWidget {
  final String? label;
  final TextStyle? styleLabel;
  final AlignmentGeometry? alignmentLabel;
  final Color? textColor;

  final IconData? icon;
  final Color? iconColor;
  final double? iconSize;

  final double? widthBTN;
  final double? heightBTN;
  final Color? colorBTN;
  final Decoration? decorationBTN;
  final double? radiusBorder;
  final double? elevation;
  final EdgeInsets? paddingBTNContent;

  final Function()? onPressed;

  XBtnbase({
    this.label = "",
    this.decorationBTN,
    this.paddingBTNContent,
    this.radiusBorder,
    this.widthBTN = 100,
    this.heightBTN = 50,
    this.alignmentLabel,
    this.elevation,
    this.icon,
    this.styleLabel,
    this.iconSize = 28,
    this.colorBTN = Colors.black,
    this.textColor,
    this.iconColor = Colors.black,
    this.onPressed,
  });

  // TextStyle styTextBaseWhite([Color? textColor]) {
  //   return TextStyle(fontSize: 14, color: Colors.white);
  // }

  // TextStyle styText3() {
  //   var s = styTextBaseWhite();
  //   var s1 = TextStyle(fontSize: 13);
  //   return s.merge(s1);
  // }

  // TextStyle styText3Black([Color? textColor]) {
  //   if (textColor == null) textColor = Colors.black;
  //   var s = styText3();
  //   var s1 = TextStyle(color: textColor);
  //   return s.merge(s1);
  // }

  @override
  Widget build(BuildContext context) {
    return Container(
        width: widthBTN,
        height: heightBTN,
        alignment: Alignment.center,
        decoration: decorationBTN ?? BoxDecoration(color: colorBTN ?? Colors.grey, borderRadius: BorderRadius.all(Radius.circular(radiusBorder ?? 0))),
        child: ElevatedButton(
          style: ElevatedButton.styleFrom(elevation: elevation ?? 10, primary: Colors.transparent, alignment: Alignment.centerLeft, padding: paddingBTNContent ?? EdgeInsets.all(5)),
          onPressed: onPressed,
          child: icon != null && (label == null || label == "")
              ? Container(
                  height: heightBTN!,
                  width: widthBTN!,
                  child: Row(mainAxisSize: MainAxisSize.min, crossAxisAlignment: CrossAxisAlignment.center, mainAxisAlignment: MainAxisAlignment.center, children: [
                    Container(
                      alignment: Alignment.center,
                      child: Icon(
                        icon,
                        color: iconColor,
                        size: iconSize,
                      ),
                    ),
                  ]))
              : Row(
                  crossAxisAlignment: CrossAxisAlignment.center,
                  children: [
                    icon != null
                        ? Container(
                            alignment: Alignment.center,
                            child: Icon(
                              icon,
                              color: iconColor,
                              size: iconSize,
                            ))
                        : Container(),
                    label != null ? Expanded(child: Container(alignment: alignmentLabel ?? Alignment.center, child: Text(label!, style: styleLabel ?? XStyles.xStyleText(fontSize: 13, colorText: textColor)))) : Container(),
                  ],
                ),
        ));
  }
}
